pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT > Class Template Reference

`#include <pcl/features/pfhrgb.h>`

Inheritance diagram for pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >:

## Public Types

using | Ptr = shared_ptr< PFHRGBEstimation< PointInT, PointNT, PointOutT > >
using | ConstPtr = shared_ptr< const PFHRGBEstimation< PointInT, PointNT, PointOutT > >
using | PointCloudOut = typename Feature< PointInT, PointOutT >::PointCloudOut
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::PFHRGBSignature250 >
using | PointCloudN = pcl::PointCloud< PointNT >
using | PointCloudNPtr = typename PointCloudN::Ptr
using | PointCloudNConstPtr = typename PointCloudN::ConstPtr
using | Ptr = shared_ptr< FeatureFromNormals< PointInT, PointNT, pcl::PFHRGBSignature250 > >
using | ConstPtr = shared_ptr< const FeatureFromNormals< PointInT, PointNT, pcl::PFHRGBSignature250 > >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| PFHRGBEstimation ()
bool | computeRGBPairFeatures (const pcl::PointCloud< PointInT > &cloud, const pcl::PointCloud< PointNT > &normals, int p_idx, int q_idx, float &f1, float &f2, float &f3, float &f4, float &f5, float &f6, float &f7)
void | computePointPFHRGBSignature (const pcl::PointCloud< PointInT > &cloud, const pcl::PointCloud< PointNT > &normals, const pcl::Indices &indices, int nr_split, Eigen::VectorXf &pfhrgb_histogram)
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::PFHRGBSignature250 >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Abstract feature estimation method. More...
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::PFHRGBSignature250 >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::PFHRGBSignature250 >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT = pcl::PFHRGBSignature250>
class pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >

Definition at line 47 of file pfhrgb.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHRGBSignature250>

using pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::ConstPtr = shared_ptr<const PFHRGBEstimation<PointInT, PointNT, PointOutT> >

Definition at line 51 of file pfhrgb.h.

## PointCloudOut

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHRGBSignature250>

using pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 58 of file pfhrgb.h.

## Ptr

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHRGBSignature250>

using pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::Ptr = shared_ptr<PFHRGBEstimation<PointInT, PointNT, PointOutT> >

Definition at line 50 of file pfhrgb.h.

## Constructor & Destructor Documentation

## PFHRGBEstimation()

template<typename PointInT , typename PointNT , typename PointOutT = pcl::PFHRGBSignature250>

pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::PFHRGBEstimation | ( |  | ) |

inline

Definition at line 61 of file pfhrgb.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## computeFeature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected virtual

Abstract feature estimation method.

Parameters

  [out] | output | the resultant features

nr_subdiv^3 for RGB and nr_subdiv^3 for the angular features

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 135 of file pfhrgb.hpp.

## computePointPFHRGBSignature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::computePointPFHRGBSignature | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const pcl::PointCloud< PointNT > & | normals,
|  | const pcl::Indices & | indices,
|  | int | nr_split,
|  | Eigen::VectorXf & | pfhrgb_histogram
| ) |  |

Definition at line 64 of file pfhrgb.hpp.

References pcl::computeRGBPairFeatures(), and M_PI.

## computeRGBPairFeatures()

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::PFHRGBEstimation< PointInT, PointNT, PointOutT >::computeRGBPairFeatures | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const pcl::PointCloud< PointNT > & | normals,
|  | int | p_idx,
|  | int | q_idx,
|  | float & | f1,
|  | float & | f2,
|  | float & | f3,
|  | float & | f4,
|  | float & | f5,
|  | float & | f6,
|  | float & | f7
| ) |  |

Definition at line 47 of file pfhrgb.hpp.

References pcl::computeRGBPairFeatures().

The documentation for this class was generated from the following files:

- pcl/features/pfhrgb.h
- pcl/features/impl/pfhrgb.hpp